package com.extensibility.win32;

import com.extensibility.app.DialogFactory;
import com.extensibility.rock.Platform;
import com.extensibility.util.Debug;
import com.extensibility.util.StringUtilities;
import java.awt.Rectangle;
import java.io.StringWriter;

public class Win32Platform extends Platform {
   protected DialogFactory doMakeDialogFactory() {
      if (Win32CommDialogs.libraryFound()) {
         return new Win32CommDialogs();
      } else {
         Debug.trace("doMakeDialogFactory: Win32 dialogs DLL not found");
         return super.doMakeDialogFactory();
      }
   }

   public Win32Platform() {
      super(1);
   }

   protected void doGetWorkArea(Rectangle var1) {
      if (Win32CommDialogs.libraryFound()) {
         (new Win32CommDialogs()).getWorkSpace(var1);
      } else {
         Debug.trace("doGetWorkArea: Win32 dialogs DLL not found");
         super.doGetWorkArea(var1);
      }

   }

   public native void getWorkSpace(Rectangle var1);

   protected String prepStringForTextArea(String var1) {
      return StringUtilities.convertLineEndings(var1, "\n");
   }

   protected StringWriter getStringWriter() {
      return new WinTextAreaStringWriter();
   }
}
